-- name: \\#ff6b91\\Veph the Dolphin-Fox
-- incompatible:
-- description: [v2]\n\nIntroduces \\#ff6b91\\Veph the Dolphin-Fox\\#ffffff\\ as a playable character.\n\nDo \\#ff6b91\\/veph on\\#ffffff\\ in chat to play as him!\n\nPressing \\#4d85fe\\A\\#ffffff\\ midair activates \\#ff6b91\\Dolphin Dive\\#ffffff\\, pressing \\#00ffb0\\B\\#ffffff\\ while running or midair uses \\#00ffb0\\Slime Tail\\#ffffff\\, and pressing \\#4d85fe\\A\\#ffffff\\ during \\#00ffb0\\Slime Tail\\#ffffff\\ starts \\#4d85fe\\Water Drive\\#ffffff\\.\n\nCharacter and Lua - \\#ff6b91\\SMS Alfredo\\#ffffff\\\nModel - \\#ff5c26\\AngelicMiracles

--Define Models
E_MODEL_VEPH = smlua_model_util_get_id("veph_geo")
E_MODEL_VEPH_GOOP = smlua_model_util_get_id("veph_goop_geo")
E_MODEL_VEPH_PUDDLE = smlua_model_util_get_id("veph_puddle_geo")

E_MODEL_VEPH_CAP = smlua_model_util_get_id("veph_cap_geo")
E_MODEL_VEPH_METAL_CAP = smlua_model_util_get_id("veph_metal_cap_geo")
E_MODEL_VEPH_WING_CAP = smlua_model_util_get_id("veph_wing_cap_geo")
E_MODEL_VEPH_WINGED_METAL_CAP = smlua_model_util_get_id("veph_winged_metal_cap_geo")

--Define Colorless Models
E_MODEL_VEPH_C = smlua_model_util_get_id("veph_c_geo")
E_MODEL_VEPH_C_GOOP = smlua_model_util_get_id("veph_c_goop_geo")
E_MODEL_VEPH_C_PUDDLE = smlua_model_util_get_id("veph_c_puddle_geo")

E_MODEL_VEPH_C_CAP = smlua_model_util_get_id("veph_c_cap_geo")
E_MODEL_VEPH_C_METAL_CAP = smlua_model_util_get_id("veph_c_metal_cap_geo")
E_MODEL_VEPH_C_WING_CAP = smlua_model_util_get_id("veph_c_wing_cap_geo")
E_MODEL_VEPH_C_WINGED_METAL_CAP = smlua_model_util_get_id("veph_c_winged_metal_cap_geo")

--Define actions
ACT_VEPH_DIVE = allocate_mario_action(ACT_FLAG_AIR | ACT_GROUP_AIRBORNE | ACT_FLAG_ATTACKING | ACT_FLAG_SWIMMING_OR_FLYING | ACT_FLAG_SHORT_HITBOX | ACT_FLAG_INVULNERABLE)
ACT_VEPH_SLIDE = allocate_mario_action(ACT_FLAG_MOVING | ACT_GROUP_MOVING | ACT_FLAG_ATTACKING | ACT_FLAG_BUTT_OR_STOMACH_SLIDE | ACT_FLAG_SWIMMING_OR_FLYING | ACT_FLAG_SHORT_HITBOX)
ACT_VEPH_DRIVE = allocate_mario_action(ACT_FLAG_AIR | ACT_GROUP_AIRBORNE)
ACT_VEPH_TAIL_AIR = allocate_mario_action(ACT_FLAG_AIR | ACT_GROUP_AIRBORNE | ACT_FLAG_ATTACKING)
ACT_VEPH_TAIL_GROUND = allocate_mario_action(ACT_FLAG_MOVING | ACT_GROUP_MOVING | ACT_FLAG_ATTACKING)
ACT_VEPH_TAIL_CHARGE = allocate_mario_action(ACT_FLAG_MOVING | ACT_GROUP_MOVING | ACT_FLAG_ATTACKING)
ACT_VEPH_GROUND_POUND = allocate_mario_action(ACT_FLAG_MOVING | ACT_FLAG_ATTACKING | ACT_GROUP_SUBMERGED | ACT_FLAG_SWIMMING | ACT_FLAG_WATER_OR_TEXT)
ACT_VEPH_GROUND_POUND_LAND = allocate_mario_action(ACT_FLAG_STATIONARY | ACT_GROUP_SUBMERGED | ACT_FLAG_METAL_WATER)

ACT_OMM_TWIRL_PROBABLY = 1090521221 --Why do I have to do this...

--Define sounds
local veph_stream = audio_sample_load("VEPH_HAPPY.mp3")

--What actions translate to what eye states?
local VP_EYEACTIONS = {
    --Goggles
    [ACT_VEPH_DIVE] = MARIO_EYES_LOOK_LEFT,
    [ACT_VEPH_SLIDE] = MARIO_EYES_LOOK_LEFT,
    [ACT_FLYING] = MARIO_EYES_LOOK_LEFT,
    [ACT_FLYING_TRIPLE_JUMP] = MARIO_EYES_LOOK_LEFT,
    [ACT_VEPH_DRIVE] = MARIO_EYES_LOOK_LEFT,
    
    --Angry
    [ACT_VEPH_TAIL_AIR] = MARIO_EYES_LOOK_UP,
    [ACT_VEPH_TAIL_GROUND] = MARIO_EYES_LOOK_UP,
    [ACT_VEPH_TAIL_CHARGE] = MARIO_EYES_LOOK_UP,

    --Open mouth
    [ACT_TRIPLE_JUMP_LAND] = MARIO_EYES_LOOK_RIGHT,
    [ACT_TRIPLE_JUMP_LAND_STOP] = MARIO_EYES_LOOK_RIGHT,
    [ACT_BACKFLIP_LAND] = MARIO_EYES_LOOK_RIGHT,
    [ACT_BACKFLIP_LAND_STOP] = MARIO_EYES_LOOK_RIGHT,
    [ACT_STAR_DANCE_NO_EXIT] = MARIO_EYES_LOOK_RIGHT,
    [ACT_STAR_DANCE_WATER] = MARIO_EYES_LOOK_RIGHT,
    [ACT_SLIDE_KICK] = MARIO_EYES_LOOK_RIGHT,
    [ACT_SLIDE_KICK_SLIDE] = MARIO_EYES_LOOK_RIGHT,

    --Look down
    [ACT_GROUND_POUND] = MARIO_EYES_LOOK_DOWN,
    [ACT_GROUND_POUND_LAND] = MARIO_EYES_LOOK_DOWN,

    --Pain
    [ACT_FORWARD_AIR_KB] = MARIO_EYES_DEAD,
    [ACT_FORWARD_GROUND_KB] = MARIO_EYES_DEAD,
    [ACT_FORWARD_WATER_KB] = MARIO_EYES_DEAD,
    [ACT_HARD_FORWARD_AIR_KB] = MARIO_EYES_DEAD,
    [ACT_HARD_FORWARD_GROUND_KB] = MARIO_EYES_DEAD,
    [ACT_SOFT_FORWARD_GROUND_KB] = MARIO_EYES_DEAD,
    [ACT_THROWN_FORWARD] = MARIO_EYES_DEAD,

    [ACT_BACKWARD_AIR_KB] = MARIO_EYES_DEAD,
    [ACT_BACKWARD_GROUND_KB] = MARIO_EYES_DEAD,
    [ACT_BACKWARD_WATER_KB] = MARIO_EYES_DEAD,
    [ACT_HARD_BACKWARD_AIR_KB] = MARIO_EYES_DEAD,
    [ACT_HARD_BACKWARD_GROUND_KB] = MARIO_EYES_DEAD,
    [ACT_SOFT_FORWARD_GROUND_KB] = MARIO_EYES_DEAD,
    [ACT_THROWN_BACKWARD] = MARIO_EYES_DEAD,
    [ACT_GROUND_BONK] = MARIO_EYES_DEAD,

    [ACT_FALLING_DEATH_EXIT] = MARIO_EYES_DEAD,
    [ACT_DEATH_EXIT_LAND] = MARIO_EYES_DEAD,

    [ACT_SHOCKED] = MARIO_EYES_DEAD,
    [ACT_WATER_SHOCKED] = MARIO_EYES_DEAD,

    [ACT_LEDGE_GRAB] = MARIO_EYES_DEAD,
    [ACT_GETTING_BLOWN] = MARIO_EYES_DEAD,
    [ACT_CAUGHT_IN_WHIRLPOOL] = MARIO_EYES_DEAD,
}

--What actions do we get to use the dive in?
local VP_MOVEACTIONS = {
    [ACT_AIR_HIT_WALL] = true,
    [ACT_AIR_THROW] = true,
    [ACT_BACKFLIP] = true,
    [ACT_BURNING_JUMP] = true,
    [ACT_BUTT_SLIDE_AIR] = true,
    [ACT_DOUBLE_JUMP] = true,
    [ACT_EMERGE_FROM_PIPE] = true,
    [ACT_FORWARD_ROLLOUT] = true,
    [ACT_BACKWARD_ROLLOUT] = true,
    [ACT_FREEFALL] = true,
    [ACT_JUMP] = true,
    [ACT_JUMP_KICK] = true,
    [ACT_LAVA_BOOST] = true,
    [ACT_LONG_JUMP] = true,
    [ACT_SIDE_FLIP] = true,
    [ACT_STEEP_JUMP] = true,
    [ACT_TOP_OF_POLE_JUMP] = true,
    [ACT_TRIPLE_JUMP] = true,
    [ACT_SPECIAL_TRIPLE_JUMP] = true,
    [ACT_WALL_KICK_AIR] = true,
    [ACT_HOLD_JUMP] = true,
    [ACT_HOLD_WATER_JUMP] = true,

    [ACT_VEPH_DIVE] = true,
}

--Actions we're allowed to transition into a Slime Tail charge from
local VP_CHARGEACTIONS = {
    [ACT_IDLE] = true,
    [ACT_PANTING] = true,
    [ACT_WALKING] = true,
    [ACT_DECELERATING] = true,
    [ACT_BRAKING] = true,
    [ACT_BRAKING_STOP] = true,
    [ACT_FREEFALL_LAND] = true,
    [ACT_FREEFALL_LAND_STOP] = true,
}

--Actions we're allowed to super swim or ground pound in
local VP_WATERACTIONS = {
    [ACT_WATER_ACTION_END] = true,
    [ACT_WATER_IDLE] = true,
    [ACT_WATER_PLUNGE] = true,
    [ACT_BREASTSTROKE] = true,
    [ACT_FLUTTER_KICK] = true,
    [ACT_WATER_PUNCH] = true,
    [ACT_SWIMMING_END] = true,

    [ACT_HOLD_BREASTSTROKE] = true,
    [ACT_HOLD_FLUTTER_KICK] = true,
    [ACT_HOLD_SWIMMING_END] = true,
    [ACT_HOLD_WATER_ACTION_END] = true,
    [ACT_HOLD_WATER_IDLE] = true,
    [ACT_WATER_THROW] = true,
}

--Actions we're allowed to perserve momentum in
local VP_MOMENTUMACTIONS = {
    [ACT_BACKFLIP_LAND] = true,
    [ACT_DOUBLE_JUMP_LAND] = true,
    [ACT_FREEFALL_LAND] = true,
    [ACT_HOLD_FREEFALL_LAND] = true,
    [ACT_HOLD_JUMP_LAND] = true,
    [ACT_HOLD_WALKING] = true,
    [ACT_JUMP_LAND] = true,
    [ACT_LONG_JUMP_LAND] = true,
    [ACT_SIDE_FLIP_LAND] = true,
    [ACT_TRIPLE_JUMP_LAND] = true,
    [ACT_WALKING] = true,
}

--Character models to replace while playing as Veph
local VP_REPLACE_PLAYER = 1
local VP_REPLACE_CAP = 2
local VP_REPLACE_METAL = 3
local VP_REPLACE_WING = 4
local VP_REPLACE_METALWING = 5
local VP_REPLACE_MODELS = {}
for i = 0, CT_MAX - 1 do
    local character = gCharacters[i]
    VP_REPLACE_MODELS[character.modelId] = VP_REPLACE_PLAYER
    VP_REPLACE_MODELS[character.capModelId] = VP_REPLACE_CAP
    VP_REPLACE_MODELS[character.capMetalModelId] = VP_REPLACE_METAL
    VP_REPLACE_MODELS[character.capWingModelId] = VP_REPLACE_WING
    VP_REPLACE_MODELS[character.capMetalWingModelId] = VP_REPLACE_METALWING
end

local SQUISHTIME = 12 --How much time you get squished!
local TAILTIME = 12 --How much time slime tail lasts
local SWIMSPEED = 96 --How fast the fast flutter kick goes
local GOOPDESPAWN = 5 --How long it takes for a goop to despawn
local GOOPTIME = 5*30 - GOOPDESPAWN --How long each goop lasts before despawning
local MAXGOOPS = 32 --How many goops are allowed at one time

--Goop interaction flags
local GOOPINTERACT = INTERACT_KOOPA | INTERACT_BULLY | INTERACT_BREAKABLE | INTERACT_BOUNCE_TOP | INTERACT_BOUNCE_TOP2 | INTERACT_HIT_FROM_BELOW
local COOPSUBINTERACT = INT_SUBTYPE_KICKABLE
local GOOPNOINTERACT = INTERACT_PLAYER | INTERACT_DOOR

--Goop toggle
gGlobalSyncTable.vephgoop = true

--Custom player variables
gVephVariables = {}
for i = 0, (MAX_PLAYERS - 1) do
    gVephVariables[i] = {}
    local v = gVephVariables[i]
    
    v.vephdiving = 0 --1 if we're in a downwards dive, 2 if we're in a hop, 3 if we're in a drive dash
    v.vephsquish = 0 --Timer for getting squished
    v.vephprevmomy = 0 --Previous vertical momentum
    v.vephmomy = 0 --Vertical momentum when bouncing
    v.vephhmom = 0 --Horizontal momentum when bouncing
    v.vephprevaction = 0 --Previous action
    v.vephprevanim = 0 --Previous animation
    v.vephtailed = 0 --Counts Slime Tail vertical momentum additions, 1 is intial boost, 2 is second boost, and 3 is Water Drive
    v.vephtail = 0 --Timer for Slime Tail
    v.vephcharged = false --Whether or not we did a charged Slime Tail
    v.vephchargeangle = 0 --Stafe angle for the charge
    v.wasveph = false --Were you Veph?
    v.vephprevhmom = 0 --Previous horizontal momentum
    v.vephprevhurt = 0 --Previous hurtCounter
    v.vephwalljump = false --Were we in a wall kick this jump?
    v.vephswim = 0 --Swimming speed
    v.vephwatercamaction = 0 --If we leave this action, reset the underwater camera
    v.vephvoicetimer = 0 --Time we do a eye state based on a voice clip
    v.vephvoiceeyes = MARIO_EYES_BLINK --Eye state we do based on a voice clip
end

--Function to play one of Veph's sounds
function veph_play_sound(pos, sound)
    veph_stream = audio_sample_load(sound)
    audio_sample_play(veph_stream, pos, 1)
end

--Define goop object
--- @param o Object
function bhv_veph_goop_init(o)
    o.oFlags = (OBJ_FLAG_COMPUTE_DIST_TO_MARIO | OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE | OBJ_FLAG_SET_FACE_ANGLE_TO_MOVE_ANGLE)
    o.hitboxRadius = 64
    o.hitboxHeight = 64
    o.oGravity = 2.5
    o.oBuoyancy = 1.3
    o.oIntangibleTimer = 0
    o.oInteractType = o.oInteractType | INTERACT_PLAYER

    o.oUnk94 = 0 --Grounded state
    o.oUnkBC = 2 --Grounded squish
    o.oUnkC0 = 0 --Despawn timer
    
    network_init_object(o, true, {
        'oPosX',
        'oPosY',
        'oPosZ',
        'oMoveAngleYaw',
        'oForwardVel',
        'oVelY',
        'oUnkC0',
    })
end

--Stupid object_step but without water stuff
function veph_goop_step(o)
    local objX = o.oPosX
    local objY = o.oPosY
    local objZ = o.oPosZ

    local floorY
    local waterY = gLevelValues.floorLowerLimitMisc

    local objVelX = o.oForwardVel * sins(o.oMoveAngleYaw)
    local objVelZ = o.oForwardVel * coss(o.oMoveAngleYaw)

    local collisionFlags = 0

    -- Find any wall collisions, receive the push, and set the flag.
    if obj_find_wall(objX + objVelX, objY, objZ + objVelZ, objVelX, objVelZ) == 0 then
        collisionFlags = collisionFlags + OBJ_COL_FLAG_HIT_WALL
    end

    cur_obj_update_floor()
    floorY = o.oFloorHeight
    if turn_obj_away_from_steep_floor(o.oFloor, floorY, objVelX, objVelZ) == 1 then
        waterY = find_water_level(objX + objVelX, objZ + objVelZ)
        if waterY > objY then
            calc_new_obj_vel_and_pos_y_underwater(o.oFloor, floorY, objVelX, objVelZ, waterY)
            collisionFlags = collisionFlags + OBJ_COL_FLAG_UNDERWATER
        else
            calc_new_obj_vel_and_pos_y(o.oFloor, floorY, objVelX, objVelZ)
        end
    else
        -- Treat any awkward floors similar to a wall.
        collisionFlags = collisionFlags +
            ((collisionFlags & OBJ_COL_FLAG_HIT_WALL) ^ OBJ_COL_FLAG_HIT_WALL)
    end

    obj_update_pos_vel_xz()
    if o.oPosY ==  floorY then
        collisionFlags = collisionFlags + OBJ_COL_FLAG_GROUNDED
    end

    if o.oVelY == 0 then
        collisionFlags = collisionFlags + OBJ_COL_FLAG_NO_Y_VEL
    end

    return collisionFlags
end

--Goop thinker
--- @param o Object
function bhv_veph_goop_loop(o)
    local playsound = false

    --Kill enemies
    if o.oUnkC0 == 0 and o.numCollidedObjs > 0 then
        local other = obj_get_collided_object(o, 0)
        if o.oHiddenObjectUnkF4 ~= other and obj_is_valid_for_interaction(other)
        and ((other.oInteractType & GOOPINTERACT) ~= 0 or (other.oInteractionSubtype & COOPSUBINTERACT) ~= 0)
        and (other.oInteractType & GOOPNOINTERACT) == 0 then
            o.oHiddenObjectUnkF4 = other
            other.oInteractStatus = other.oInteractStatus | ATTACK_KICK_OR_TRIP | INT_STATUS_WAS_ATTACKED | INT_STATUS_INTERACTED
            if (other.oInteractType & INTERACT_BULLY) ~= 0 then
                other.oForwardVel = o.oForwardVel
                other.oMoveAngleYaw = o.oMoveAngleYaw
                o.oBullyLastNetworkPlayerIndex = o.globalPlayerIndex
            elseif get_id_from_behavior(other.behavior) == id_bhvPokey
            or get_id_from_behavior(other.behavior) == id_bhvPokeyBodyPart then
                other.oInteractStatus = other.oInteractStatus | ATTACK_FAST_ATTACK &~ ATTACK_KICK_OR_TRIP
            end
            if (other.oSyncID ~= 0) then
                network_send_object(other, true)
            end

            playsound = true
            o.oUnkBC = 2
            if (o.oSyncID ~= 0) then
                network_send_object(o, true)
            end
        end
    end

    --[[
    --Collect coins
    local coin = obj_get_nearest_object_with_behavior_id(o, id_bhvYellowCoin)
    if coin ~= nil and obj_check_hitbox_overlap(o, coin) then
        local m = gMarioStates[network_local_index_from_global(o.globalPlayerIndex)]
        obj_set_pos(coin, m.pos.x, m.pos.y, m.pos.z)
    end
    ]]--

    --Step forward
    local step = veph_goop_step(o)
    obj_check_floor_death(step, o.oFloor)

    --Death plane
    if o.oAction == OBJ_ACT_DEATH_PLANE_DEATH then
        obj_mark_for_deletion(o)
        return

    --Midair
    elseif o.oUnk94 == 0 then
        --Squishy goop
        if o.oUnkC0 == 0 then
            local momentum = math.min(math.max(o.oVelY/32, -0.5), 0.5)
            o.header.gfx.scale.x = 1 + math.sin(o.oTimer)/16 + momentum
            o.header.gfx.scale.z = o.header.gfx.scale.x
            o.header.gfx.scale.y = 1 + math.cos(o.oTimer)/16 - momentum
        end

        --Splat on the ground!
        if ((step & OBJ_COL_FLAG_GROUNDED) == OBJ_COL_FLAG_GROUNDED
        or (step & OBJ_COL_FLAGS_LANDED) == OBJ_COL_FLAGS_LANDED)
        and (step & OBJ_COL_FLAG_UNDERWATER) ~= OBJ_COL_FLAG_UNDERWATER then
            if o.oUnk1A8 == 2 then
                obj_set_model_extended(o, E_MODEL_VEPH_C_PUDDLE)
            else
                obj_set_model_extended(o, E_MODEL_VEPH_PUDDLE)
            end
            o.oUnk94 = 1
            o.oVelY = 0
            playsound = true
        end

    --On ground
    elseif o.oUnkBC ~= 1 and o.oUnkC0 == 0 then
        o.oUnkBC = (o.oUnkBC-1)*0.75 + 1
        o.header.gfx.scale.x = o.oUnkBC
        o.header.gfx.scale.z = o.oUnkBC
    end

    --Play sound
    if playsound and o.oAction ~= OBJ_ACT_LAVA_DEATH  then
        veph_play_sound({x = o.oPosX, y = o.oPosY, z = o.oPosZ}, "DSVPGOP"..tostring(math.random(3))..".mp3")
    end

    --Shrink automatically after some time, then delete the goop
    if o.oUnkC0 ~= 0 then
        local scale = 1 - o.oUnkC0/GOOPDESPAWN
        o.header.gfx.scale.x = scale
        o.header.gfx.scale.z = scale
        if o.oUnk94 == 0 then
            o.header.gfx.scale.y = scale
        end

        o.oUnkC0 = o.oUnkC0 + 1
        if o.oUnkC0 > GOOPDESPAWN then
            obj_mark_for_deletion(o)
        end
    elseif o.oTimer > GOOPTIME or o.oAction == OBJ_ACT_LAVA_DEATH then
        o.oUnkC0 = 1
    end
end

id_bhvVephGoop = hook_behavior(nil, OBJ_LIST_DESTRUCTIVE, true, bhv_veph_goop_init, bhv_veph_goop_loop)

--Despawn goops if there are too many
--We need to it this way in order to prevent despawning every goop at once
--since they need to shrink before being deleted
local oUnkC0_id = 0x0E
function veph_goop_update()
    --Get all of the goops that aren't despawning
    local o = obj_get_first_with_behavior_id_and_field_f32(id_bhvVephGoop, oUnkC0_id, 0)
    local gooplist = {}
    while o ~= nil do
        if network_local_index_from_global(o.globalPlayerIndex) == 0 then
            table.insert(gooplist, o)
        end
        o = obj_get_next_with_same_behavior_id_and_field_f32(o, oUnkC0_id, 0)
    end

    local goopnum = #gooplist
    if goopnum <= MAXGOOPS then return end --We're not over the limit

    --Iterate through the goops we're going to despawn
    local goopstodelete = goopnum - MAXGOOPS
    table.sort(gooplist, function(o1, o2)
        return o1.oTimer > o2.oTimer
    end)
    for i, goop in ipairs(gooplist) do
        if i > goopstodelete then return end
        goop.oUnkC0 = 1
    end
end
hook_event(HOOK_UPDATE, veph_goop_update)

--Turn assist function
--- @param m MarioState
function veph_turn_assist(m)
    local v = gVephVariables[m.playerIndex]
    local oldspeed = m.forwardVel
    local oldangle = m.faceAngle.y
    local factor = math.max(math.max(81 - oldspeed*3/2, 12) - math.max(oldspeed/3 - 36, 0), 6)*0.75

    if (m.input & INPUT_NONZERO_ANALOG) == 0 then
        return
    elseif v.vephdiving >= 2 or v.vephwalljump then
        return
    elseif not (m.action == ACT_VEPH_DIVE and v.vephdiving == 1) then
        factor = factor/2
    end
    
    local newspeed = m.intendedMag*0.78125/factor
    local momx = m.vel.x + sins(m.intendedYaw)*newspeed
    local momz = m.vel.z + coss(m.intendedYaw)*newspeed
    
    local newangle = atan2s(momz, momx)
    newspeed = math.sqrt(momx*momx + momz*momz)
    if newspeed > oldspeed
    and not ((m.action & ACT_FLAG_AIR) ~= 0 and newspeed < 16) then
        newspeed = oldspeed
    end

    --This code is supposed to make you lose speed when turning
    --However, the translation from SRB2 did not treat it kindly
    local diff = newangle - oldangle
    newspeed = math.max(newspeed - math.abs(diff)/0x1000, 0)
    
    m.faceAngle.y = newangle
    mario_set_forward_vel(m, newspeed)
end

--Ground ability action
--- @param m MarioState
function act_veph_slide(m)
    local v = gVephVariables[m.playerIndex]
    local faceAngleYaw = atan2s(m.vel.z, m.vel.x)
    faceAngleYaw = m.floorAngle - faceAngleYaw
    local grabbing = m.heldObj ~= nil

    --A few frames before we decide if we bounce!
    if m.actionTimer < 3 then
        --Nothing

    --Hold A to bounce
    elseif (m.input & INPUT_A_DOWN) ~= 0
    and m.actionTimer == 3 and v.vephmomy < -30.0 then
        m.vel.y = math.max(v.vephmomy*-0.7, 24)
        return set_mario_action(m, ACT_VEPH_DIVE, 0)
    
    --Long jump out
    elseif (m.input & INPUT_A_PRESSED) ~= 0
    and (m.controller.buttonDown & Z_TRIG) ~= 0
    and not grabbing then
        local hmom = m.forwardVel
        set_jumping_action(m, ACT_LONG_JUMP, 0)
        mario_set_forward_vel(m, hmom)
        return true

    --Slide kick out
    elseif (m.input & INPUT_B_PRESSED) ~= 0
    and (m.controller.buttonDown & Z_TRIG) ~= 0
    and not grabbing then
        local hmom = m.forwardVel
        set_jumping_action(m, ACT_SLIDE_KICK, 0)
        mario_set_forward_vel(m, hmom)
        return true

    --Little hop
    elseif (m.input & INPUT_B_PRESSED) ~= 0 then
        return set_mario_action(m, ACT_VEPH_DIVE, 2)

    --Jump out
    elseif (m.input & INPUT_A_PRESSED) ~= 0 then
        if not grabbing then
            set_jumping_action(m, ACT_STEEP_JUMP, 0)
        end
        local hmom = m.forwardVel
        local momy = m.vel.y
        if grabbing then
            set_mario_action(m, ACT_HOLD_JUMP, 0)
        else
            set_jumping_action(m, ACT_JUMP, 0)
            m.vel.y = momy
        end
        mario_set_forward_vel(m, hmom)
        return true

    --Crouch out (disabled since this kills your speed trying to do a long jump)
    --[[elseif (m.input & INPUT_Z_PRESSED) ~= 0 then
        return set_mario_action(m, ACT_CROUCH_SLIDE, 0)
    ]]--

    --Slippy Slidey
    elseif m.floor ~= nil and m.floor.normal.y <= 0.25
    and mario_floor_is_slippery(m) == true
    and (-0x4000 >= faceAngleYaw or faceAngleYaw >= 0x4000) then
        return set_mario_action(m, ACT_BEGIN_SLIDING, 0)

    --Run out of speed
    elseif m.forwardVel < 5 then
        v.vephdiving = 1
        return set_mario_action(m, grabbing and ACT_DIVE_PICKING_UP or ACT_STOMACH_SLIDE_STOP, 0)
    end

    --Check grabbable objects
    if mario_check_object_grab(m) == true then
        return true
    end

    mario_update_moving_sand(m)
    mario_update_windy_ground(m)

    play_sound(SOUND_MOVING_TERRAIN_RIDING_SHELL + (SOUND_TERRAIN_WATER << 16), m.marioObj.header.gfx.cameraToObject);
    reset_rumble_timers(m)
    adjust_sound_for_speed(m)

    veph_turn_assist(m)
    if grabbing then
        set_mario_animation(m, MARIO_ANIM_SLIDE_DIVE)
    else
        set_mario_animation(m, MARIO_ANIM_SLIDE_MOTIONLESS)
        smlua_anim_util_set_animation(m.marioObj, v.wasveph and "veph_slide" or "veph_slide_alt")
    end

    --Water effect
    spawn_non_sync_object(
        id_bhvObjectWaterSplash,
        E_MODEL_SMALL_WATER_SPLASH,
        m.pos.x, m.pos.y + 1, m.pos.z,
        function(o)
            obj_scale_random(o, 2, 1)
        end
    )

    spawn_non_sync_object(
        id_bhvWaterDroplet,
        E_MODEL_WHITE_PARTICLE_SMALL,
        m.pos.x, m.pos.y + 1, m.pos.z,
        function(o)
            obj_scale(o, 1.5)
            o.oVelY = math.random() * 30
            obj_translate_xz_random(o, 110)
        end
    )

    --Hit wall
    local ground_step = perform_ground_step(m)
    if ground_step == GROUND_STEP_LEFT_GROUND then
        set_mario_action(m, ACT_VEPH_DIVE, 0)
    elseif ground_step ~= GROUND_STEP_NONE then
        queue_rumble_data_mario(m, 5, 40)
        v.vephsquish = SQUISHTIME*4/3
        
        --Bounce off
        local hmom = m.forwardVel/2
        mario_bonk_reflection(m, false)
        mario_set_forward_vel(m, hmom)

        m.particleFlags = m.particleFlags | PARTICLE_VERTICAL_STAR
        play_sound(SOUND_ACTION_BONK, m.marioObj.header.gfx.cameraToObject)
        veph_play_sound(m.pos, "DSVPBONK.mp3")
    else
        if (m.input & INPUT_ABOVE_SLIDE) == 0 then
            apply_slope_accel(m)
        end
        apply_slope_decel(m, 0.075)
    end

    m.actionTimer = m.actionTimer + 1
    return false
end
hook_mario_action(ACT_VEPH_SLIDE, act_veph_slide, INT_FAST_ATTACK_OR_SHELL)

--Air ability action
--- @param m MarioState
function act_veph_dive(m)
    local v = gVephVariables[m.playerIndex]
    local grabbing = mario_check_object_grab(m) == true or m.heldObj ~= nil

    --First frame of diving, determine the type of dive
    if m.actionTimer == 0 then
        v.vephdiving = m.actionArg

        --Downwards dive
        if v.vephdiving == 1 then
            --play_sound(SOUND_GENERAL_SWISH_WATER, m.marioObj.header.gfx.cameraToObject)
            veph_play_sound(m.pos, "DSVPDIVE.mp3")

            m.particleFlags = m.particleFlags | PARTICLE_TRIANGLE
            v.vephsquish = -SQUISHTIME

            --Do Dive Momentum
            local hmom = m.forwardVel
            local vmom = m.vel.y

            --Vertical Momentum
            m.vel.y = vmom + math.min(hmom/-3, -32)

            --Horizontal Momentum
            if m.intendedMag ~= 0 then
                local angle = m.intendedYaw
                if v.vephwalljump then angle = m.faceAngle.y end

                local addhmom = m.intendedMag*1.0417
                local momx = m.vel.x + sins(angle)*addhmom
                local momz = m.vel.z + coss(angle)*addhmom
                
                hmom = math.sqrt(momx*momx + momz*momz)
                if hmom ~= 0 then
                    m.faceAngle.y = atan2s(momz, momx)
                end
                mario_set_forward_vel(m, hmom)
            end

        --Little hop
        elseif v.vephdiving == 2 then
            veph_play_sound(m.pos, "DSVPHOP.mp3")
            if m.prevAction == ACT_VEPH_SLIDE then
                m.vel.y = 24
                mario_set_forward_vel(m, m.forwardVel + (m.forwardVel >= 120 and 8 or 16))
            else
                if (v.vephprevaction & ACT_FLAG_AIR) == 0 then
                    m.vel.y = 24
                end
                mario_set_forward_vel(m, m.forwardVel + (m.forwardVel >= 120 and 8 or 16))
            end

        --Water Drive dash
        elseif v.vephdiving == 3 then
            v.vephsquish = SQUISHTIME
            m.particleFlags = m.particleFlags | PARTICLE_TRIANGLE
            mario_set_forward_vel(m, 96)
        end
    end

    --No cancelling during the hop!
    if v.vephdiving == 2 then
        --Nothing

    --Cancel with a ground pound
    elseif (m.input & INPUT_Z_PRESSED) ~= 0 then
        mario_drop_held_object(m)
        return set_mario_action(m, ACT_GROUND_POUND, 1)

    --Cancel with Slime Tail
    elseif (m.input & INPUT_B_PRESSED) ~= 0 then
        if grabbing then
            return set_mario_action(m, ACT_AIR_THROW, 0)
        else
            return set_mario_action(m, ACT_VEPH_TAIL_AIR, 1)
        end
    end

    veph_turn_assist(m)
    if grabbing then
        set_mario_animation(m, v.vephdiving == 1 and MARIO_ANIM_DIVE or MARIO_ANIM_SLIDE_DIVE)
    elseif v.vephdiving == 1 and m.actionTimer < 6 then
        set_mario_animation(m, MARIO_ANIM_WATER_FORWARD_KB)
        set_anim_to_frame(m, m.actionTimer*8)
    else
        set_mario_animation(m, MARIO_ANIM_SLIDE_MOTIONLESS)
        smlua_anim_util_set_animation(m.marioObj, v.wasveph and "veph_slide" or "veph_slide_alt")
        set_anim_to_frame(m, 8)
    end

    if v.vephdiving == 1 then
        m.particleFlags = m.particleFlags | PARTICLE_SPARKLES
    elseif v.vephdiving == 3 then
        m.particleFlags = m.particleFlags | PARTICLE_SPARKLES
        m.vel.y = 0
        if m.actionTimer >= 16 then
            v.vephdiving = 0
        end
    end

    --Hit floor
    local air_step = perform_air_step(m, 0)
    if air_step == AIR_STEP_LANDED then
        v.vephsquish = SQUISHTIME
        v.vephdiving = 0
        v.vephmomy = m.vel.y
        v.vephhmom = m.forwardVel

        --Sound
        if v.vephmomy > -40 then
            veph_play_sound(m.pos, "DSVPLND1.mp3")
        else
            veph_play_sound(m.pos, "DSVPBNCE.mp3")
        end
        veph_play_sound(m.pos, "DSVPLND2.mp3")
        --play_sound(SOUND_OBJ_WATER_BOMB_BOUNCING, m.marioObj.header.gfx.cameraToObject)

        --Splashes
        spawn_non_sync_object(
            id_bhvSparkle,
            E_MODEL_WATER_SPLASH,
            m.pos.x, m.pos.y, m.pos.z,
            function (o)
                if o.oTimer ~= 0 then o.oTimer = 1 end

                --Water drop particles
                local pinfo = obj_get_temp_spawn_particles_info(E_MODEL_WHITE_PARTICLE_SMALL)
                pinfo.count = 8
                pinfo.forwardVelBase = 4
                pinfo.forwardVelRange = 20
                pinfo.velYBase = 20
                pinfo.velYRange = 15
                pinfo.gravity = -3
                pinfo.sizeBase = 10
                pinfo.sizeRange = 7
                cur_obj_spawn_particles(pinfo)
            end
        )

        spawn_non_sync_object(
            id_bhvObjectWaterSplash,
            E_MODEL_SMALL_WATER_SPLASH,
            m.pos.x, m.pos.y + 1, m.pos.z,
            function(o)
                obj_scale(o, 8)
            end
        )

        --Ground pound! This will transition into a slide/bounce in the main update code
        --Well, unless we'd just slide anyways, that is
        v.vephtailed = 0
        m.particleFlags = m.particleFlags | PARTICLE_HORIZONTAL_STAR &~ PARTICLE_MIST_CIRCLE
        mario_set_forward_vel(m, v.vephhmom)
        --if (m.input & INPUT_ABOVE_SLIDE) == 0 and m.floorAngle == 0 then
            --v.vephdiving = 1
            --return set_mario_action(m, ACT_GROUND_POUND_LAND, 0)
        --else
            v.vephdiving = 0
            return set_mario_action(m, ACT_VEPH_SLIDE, 0)
        --end

    --Hit wall
    elseif air_step == AIR_STEP_HIT_WALL then
        queue_rumble_data_mario(m, 5, 40)
        v.vephsquish = SQUISHTIME*4/3
        
        --Bounce off
        local hmom = m.forwardVel
        mario_bonk_reflection(m, false)
        mario_set_forward_vel(m, hmom)

        m.particleFlags = m.particleFlags | PARTICLE_VERTICAL_STAR
        play_sound(SOUND_ACTION_BONK, m.marioObj.header.gfx.cameraToObject)
        veph_play_sound(m.pos, "DSVPBONK.mp3")

    --Hit lava
    elseif air_step == AIR_STEP_HIT_LAVA_WALL then
        lava_boost_on_wall(m)
    end

    m.actionTimer = m.actionTimer + 1
    return false
end
--- @param m MarioState
function act_veph_dive_gravity(m)
    local v = gVephVariables[m.playerIndex]

    --Control your jump height, but not during the hop
    if v.vephdiving ~= 2 and m.vel.y > 20
    and (m.input & INPUT_A_DOWN) == 0 then
        m.vel.y = m.vel.y/4
    else
        m.vel.y = math.max(m.vel.y - 4.0, -150)
    end
    return true
end
hook_mario_action(ACT_VEPH_DIVE, { every_frame = act_veph_dive, gravity = act_veph_dive_gravity }, INT_FAST_ATTACK_OR_SHELL)

--Picking up stuff while sliding or diving
--- @param m MarioState
--- @param o Object
function veph_slide_grab(m, o, type, value)
    if (m.action == ACT_VEPH_SLIDE or m.action == ACT_VEPH_DIVE)
    and m.heldObj == nil and type == INTERACT_GRABBABLE
    and (o.oInteractionSubtype & (INT_SUBTYPE_NOT_GRABBABLE | INT_SUBTYPE_GRABS_MARIO)) == 0 then
        m.interactObj = o
        m.input = m.input | INPUT_INTERACT_OBJ_GRABBABLE
        set_mario_action(m, m.action == ACT_VEPH_SLIDE and ACT_DIVE_SLIDE or ACT_DIVE, 0)
        if (o.oSyncID ~= 0) then
            network_send_object(o, true)
        end
    end
end
hook_event(HOOK_ON_INTERACT, veph_slide_grab)

--Dash ability action
--- @param m MarioState
function act_veph_drive(m)
    local v = gVephVariables[m.playerIndex]

    --Start up
    if m.actionTimer == 0 then
        v.vephsquish = -SQUISHTIME
        veph_play_sound(m.pos, "DSVPDASH.mp3")

        v.vephtailed = 3
        m.faceAngle.y = m.intendedYaw

    --Ground pound cancel
    elseif (m.input & INPUT_Z_PRESSED) ~= 0 then
        return set_mario_action(m, ACT_GROUND_POUND, 1)

    --Dash forward!
    elseif m.actionTimer >= 12 then
        return set_mario_action(m, ACT_VEPH_DIVE, 3)
    end
    m.particleFlags = m.particleFlags | PARTICLE_SPARKLES

    mario_set_forward_vel(m, -20)
    m.vel.y = 0
    v.vephmomy = 0

    common_air_action_step(m, ACT_VEPH_SLIDE, MARIO_ANIM_SLOW_LAND_FROM_DIVE, 0)
    set_anim_to_frame(m, math.max(24 - m.actionTimer, 0))

    --Water effect
    spawn_non_sync_object(
        id_bhvObjectWaterSplash,
        E_MODEL_SMALL_WATER_SPLASH,
        m.pos.x, m.pos.y + 1, m.pos.z,
        function(o)
            obj_scale_random(o, 2, 1)
        end
    )

    spawn_non_sync_object(
        id_bhvWaterDroplet,
        E_MODEL_WHITE_PARTICLE_SMALL,
        m.pos.x, m.pos.y + 1, m.pos.z,
        function(o)
            obj_scale(o, 1.5)
            o.oVelY = math.random() * 30
            obj_translate_xz_random(o, 110)
        end
    )

    m.actionTimer = m.actionTimer + 1
    return false
end
hook_mario_action(ACT_VEPH_DRIVE, act_veph_drive)

--Tail ability action
--- @param m MarioState
function act_veph_tail(m)
    local v = gVephVariables[m.playerIndex]
    local grounded = (m.action & ACT_FLAG_AIR) == 0

    --End the move
    if (grounded and v.vephtail >= TAILTIME) or v.vephtail >= TAILTIME*1.125 then
        if v.vephcharged then
            v.vephtail = 0
            v.vephcharged = false
        else
            v.vephtail = TAILTIME
        end
        return set_mario_action(m, grounded and ACT_FREEFALL_LAND or ACT_FREEFALL, 0)
    end

    --Start the move
    if m.actionArg > 0 and m.actionTimer == 0 then
        --Charged Tail
        if m.actionArg == 2 then
            local moving = (m.input & INPUT_ZERO_MOVEMENT) == 0 and m.intendedMag >= 32

            --Momentum
            m.vel.y = moving and 48 or 68
            if moving then
                m.faceAngle.y = m.intendedYaw
            else
                m.faceAngle.y = v.vephchargeangle
            end
            mario_set_forward_vel(m, m.forwardVel + (moving and 80 or 16))

            --Variables
            v.vephtail = -9
            v.vephmomy = 0
            v.vephcharged = true
            veph_play_sound(m.pos, "DSVPTAL2.mp3")

        --Normal Tail
        else
            --Set the vertical momentum
            if m.actionArg == 3 then
                m.vel.y = 24
                v.vephmomy = 0
            else
                v.vephmomy = 24
            end

            --Set the horizontal momentum
            mario_set_forward_vel(m, v.vephprevhmom)
            if (m.actionArg == 3 or (m.input & INPUT_NONZERO_ANALOG) ~= 0) then
                local angle = m.intendedYaw
                if v.vephwalljump then angle = m.faceAngle.y end

                local addhmom = m.forwardVel >= 60 and 8 or 16
                local momx = m.vel.x + sins(angle)*addhmom
                local momz = m.vel.z + coss(angle)*addhmom
                
                hmom = math.sqrt(momx*momx + momz*momz)
                if hmom ~= 0 then
                    m.faceAngle.y = atan2s(momz, momx)
                end
                mario_set_forward_vel(m, hmom)
            end

            --Set the variables
            v.vephtail = 0
            v.vephcharged = false
            v.vephprevaction = m.prevAction
            veph_play_sound(m.pos, "DSVPTAIL.mp3")
        end
    end
    m.actionTimer = m.actionTimer + 1

    --Ground or air action?
    if grounded then
        --Actions with buttons grounded
        if v.vephtail <= 0 then --Nothing
        elseif (m.input & INPUT_A_PRESSED) ~= 0 then
            return set_jumping_action(m, ACT_DOUBLE_JUMP, 0)
        elseif (m.input & INPUT_Z_PRESSED) ~= 0 then
            return set_mario_action(m, ACT_CROUCH_SLIDE, 0)
        end
        update_walking_speed(m)

        --Did we leave the ground?
        local ground_step = perform_ground_step(m)
        if ground_step == GROUND_STEP_LEFT_GROUND then
            return set_mario_action(m, ACT_VEPH_TAIL_AIR, 0)
        else
            set_mario_animation(m, MARIO_ANIM_SLIDE_MOTIONLESS)
            smlua_anim_util_set_animation(m.marioObj, "veph_tail")
            play_mario_landing_sound_once(m, SOUND_ACTION_TERRAIN_LANDING)
        end
    
    --Actions with buttons midair
    elseif (m.input & INPUT_A_PRESSED) ~= 0 and v.vephtail > 0 and v.vephtailed < 3 then
        return set_mario_action(m, v.vephtail < 12 and ACT_VEPH_DRIVE or ACT_VEPH_DIVE, 1)
    elseif (m.input & INPUT_Z_PRESSED) ~= 0 and v.vephtail > 0 then
        return set_mario_action(m, ACT_GROUND_POUND, 0)

    --Air tail
    else
        --Extra vertical momentum
        if v.vephmomy > 0 and v.vephtail == 4
        and (m.controller.buttonDown & (A_BUTTON|B_BUTTON)) ~= 0 then
            if v.vephtailed == 0 then
                m.vel.y = math.max(m.vel.y, 0)
                v.vephtailed = 1
            end
            m.vel.y = m.vel.y + v.vephmomy
            v.vephmomy = 0

            if m.vel.y < 0 then
                if v.vephtailed <= 1 then
                    v.vephtailed = 2
                    m.vel.y = 0
                else
                    m.vel.y = m.vel.y/2
                end
            end
        end

        common_air_action_step(m, ACT_VEPH_TAIL_GROUND, MARIO_ANIM_SLIDE_MOTIONLESS, 0)
        smlua_anim_util_set_animation(m.marioObj, "veph_tail")
    end
    
    --Spin animation and slime
    if v.vephtail < 8 and m.playerIndex == 0 then
        local angle = m.faceAngle.y - v.vephtail*0x2000
        --m.marioObj.header.gfx.angle.y = angle
        --set_anim_to_frame(m, math.abs(v.vephtail*6))

        for i = 0, 1 do
            if i ~= 0 then angle = angle - 0x1000 end

            local x = m.pos.x - sins(angle)*64
            local y = m.pos.y + 16
            local z = m.pos.z - coss(angle)*64

            local momx = m.vel.x - sins(angle)*16
            local momy = 16 --m.vel.y
            local momz = m.vel.z - coss(angle)*16

            x = x + m.vel.x/2*i - momx
            y = y + m.vel.y/2*i - momy
            z = z + m.vel.z/2*i - momz
            
            local goopbhv = id_bhvVephGoop
            local goopmodel = E_MODEL_VEPH_GOOP
            local vephtype = gPlayerSyncTable[m.playerIndex].vephenabled
            local goopfunction = spawn_sync_object
            if not gGlobalSyncTable.vephgoop then
                goopbhv = id_bhvWhitePuffExplosion
                goopmodel = E_MODEL_WHITE_PARTICLE_DL
                goopfunction = spawn_non_sync_object
            elseif vephtype == 2 then
                goopmodel = E_MODEL_VEPH_C_GOOP
            end

            goopfunction(goopbhv, goopmodel, x, y, z,
            --- @param o Object
            function(o)
                o.oMoveAngleYaw = atan2s(momz, momx)
                o.oFaceAngleYaw = o.oMoveAngleYaw
                o.oForwardVel = math.sqrt(momx*momx + momz*momz)

                o.oVelY = momy
                if not gGlobalSyncTable.vephgoop then
                    o.oGravity = -2.5
                end
                
                o.globalPlayerIndex = gNetworkPlayers[m.playerIndex].globalIndex
                o.parentObj = m.marioObj
                o.oUnk1A8 = vephtype
            end)
        end
    end

    set_anim_to_frame(m, math.abs(v.vephtail + 8))
    v.vephtail = v.vephtail + 1
end
--- @param m MarioState
function act_veph_tail_gravity(m)
    --Lower gravity when falling
    local v = gVephVariables[m.playerIndex]
    if m.vel.y < 0 and m.actionArg < 3
    and v.vephtail < TAILTIME then
        m.vel.y = math.max(m.vel.y - 2.0, -75)
    else
        m.vel.y = math.max(m.vel.y - 4.0, -75)
    end
    return true
end
hook_mario_action(ACT_VEPH_TAIL_AIR, { every_frame = act_veph_tail, gravity = act_veph_tail_gravity }, INT_FAST_ATTACK_OR_SHELL)
hook_mario_action(ACT_VEPH_TAIL_GROUND, act_veph_tail, INT_FAST_ATTACK_OR_SHELL)

--Activate Slime Tail by Diving
--Also perserve vertical momentum angle when entering water
--- @param m MarioState
function veph_activate_tail(m)
    local v = gVephVariables[m.playerIndex]
    local grounded = (v.vephprevaction & ACT_FLAG_AIR) == 0
    local vephenabled = gPlayerSyncTable[m.playerIndex].vephenabled
    if vephenabled ~= 1 and vephenabled ~= 2 and vephenabled ~= 3 then return end

    --djui_chat_message_create(tostring(m.action))

    --Perserve vertical momentum angle into water
    if m.action == ACT_WATER_PLUNGE and m.forwardVel >= 0 then
        m.faceAngle.x = atan2s(m.forwardVel, m.vel.y/4)

        --Instant flutter kick
        if (m.input & INPUT_A_DOWN) ~= 0 then
            play_sound(SOUND_ACTION_UNKNOWN430, m.marioObj.header.gfx.cameraToObject)
            if m.peakHeight - m.pos.y > 1150.0 then
                play_character_sound(m, CHAR_SOUND_HAHA_2)
            end

            set_mario_particle_flags(m, PARTICLE_WATER_SPLASH, false)
            if (m.prevAction & ACT_FLAG_AIR) ~= 0 then
                queue_rumble_data_mario(m, 5, 80)
            end

            set_mario_action(m, m.heldObj ~= nil and ACT_HOLD_FLUTTER_KICK or ACT_FLUTTER_KICK, 0)
        end

    --Activate Slime Tail
    elseif (m.action == ACT_DIVE and m.prevAction ~= ACT_GROUND_POUND
    and (m.input & INPUT_INTERACT_OBJ_GRABBABLE) == 0)
    or (m.action == ACT_JUMP_KICK and not grounded)
    or (m.action == ACT_MOVE_PUNCHING and m.forwardVel >= 29 and m.controller.stickMag > 48) then
        m.vel.y = v.vephprevmomy
        set_mario_action(m, ACT_VEPH_TAIL_AIR, grounded and 3 or 1)
    end
end
hook_event(HOOK_ON_SET_MARIO_ACTION, veph_activate_tail)

--Replace OMM twirl with Dolphin Dive
--- @param m MarioState
function veph_activate_dive(m, action)
    --Activate Dolphin Dive
    if action == ACT_OMM_TWIRL_PROBABLY and (m.controller.buttonPressed & A_BUTTON) ~= 0 then
        set_mario_action(m, ACT_VEPH_DIVE, 1)
        return 1
    end
end
hook_event(HOOK_BEFORE_SET_MARIO_ACTION, veph_activate_dive)

--Tail Charge ability action
--- @param m MarioState
function act_veph_charge(m)
    local v = gVephVariables[m.playerIndex]

    --Start the charge
    if m.actionTimer == 0 then
        mario_set_forward_vel(m, m.forwardVel/2)
        v.vephsquish = SQUISHTIME/-3
        v.vephchargeangle = m.faceAngle.y

        local angle = m.faceAngle.y + 0x2000
        spawn_non_sync_object(
            id_bhvSparkle,
            E_MODEL_SPARKLES_ANIMATION,
            m.pos.x - sins(angle)*64,
            m.pos.y + 16,
            m.pos.z - coss(angle)*64,
            nil
        )
        veph_play_sound(m.pos, "DSVPFULL.mp3")

    --Jump out
    elseif (m.input & INPUT_A_PRESSED) ~= 0 then
        return set_jumping_action(m, ACT_JUMP, 0)

    --Duck out
    elseif (m.input & INPUT_Z_PRESSED) ~= 0 then
        return set_jumping_action(m, ACT_START_CROUCHING, 0)

    --End the charge and perform the Super Slime Tail!
    elseif (m.controller.buttonDown & B_BUTTON) == 0 then
        return set_mario_action(m, ACT_VEPH_TAIL_AIR, 2)
    end
    
    m.intendedMag = m.intendedMag*0.2
    update_walking_speed(m)

    --Did we leave the ground?
    local ground_step = perform_ground_step(m)
    if ground_step == GROUND_STEP_LEFT_GROUND then
        return set_mario_action(m, ACT_FREEFALL, 0)
    else
        set_mario_anim_with_accel(m, MARIO_ANIM_SLIDE_MOTIONLESS, m.intendedMag * 0x10000)
        smlua_anim_util_set_animation(m.marioObj, "veph_charge")
        play_step_sound(m, 55, 55)

        m.marioObj.header.gfx.angle.y = v.vephchargeangle
    end

    m.actionTimer = m.actionTimer + 1
    return false
end
hook_mario_action(ACT_VEPH_TAIL_CHARGE, act_veph_charge)

--Underwater Ground Pound action
--- @param m MarioState
function act_veph_ground_pound(m)
    local v = gVephVariables[m.playerIndex]
    
    --Cancel by pressing A or B
    if m.actionTimer > 5 or m.actionState > 0 then
        if (m.input & INPUT_A_PRESSED) ~= 0 then
            play_sound(SOUND_ACTION_SWIM_FAST, m.marioObj.header.gfx.cameraToObject)
            v.vephswim = 96
            return set_mario_action(m, ACT_BREASTSTROKE, 0)
        elseif (m.input & INPUT_B_PRESSED) ~= 0 then
            return set_mario_action(m, ACT_WATER_PUNCH, 0)
        end
    end

    --Reset our angle
    vec3s_set(m.angleVel, 0, 0, 0)
    m.marioObj.header.gfx.angle.x = 0
    m.marioObj.header.gfx.angle.z = 0

    --Start up
    if (m.actionState == 0) then
        set_mario_animation(m, MARIO_ANIM_TRIPLE_JUMP_GROUND_POUND)
        if (m.actionTimer == 0) then
            play_sound(SOUND_ACTION_UNKNOWN434, m.marioObj.header.gfx.cameraToObject)
            mario_set_forward_vel(m, m.forwardVel/2)
            v.vephswim = m.forwardVel
        end

        m.vel.y = 0
        perform_water_step(m)
        if (m.actionTimer > 12) then
            play_character_sound(m, CHAR_SOUND_GROUND_POUND_WAH)
            m.actionState = 1
            m.actionTimer = 0

            mario_set_forward_vel(m, 0)
            v.vephswim = 0
        end

    --Going down
    else
        set_mario_animation(m, MARIO_ANIM_GROUND_POUND)
        m.particleFlags = m.particleFlags | PARTICLE_PLUNGE_BUBBLE
        m.vel.y = math.max(-50 - m.actionTimer*2, -150)

        local stepResult = perform_water_step(m)
        if (stepResult == WATER_STEP_HIT_FLOOR or stepResult == WATER_STEP_CANCELLED) then
            play_sound(SOUND_ACTION_TERRAIN_HEAVY_LANDING, m.marioObj.header.gfx.cameraToObject)
            set_mario_particle_flags(m, (PARTICLE_MIST_CIRCLE | PARTICLE_HORIZONTAL_STAR), false)
            if (m.playerIndex == 0) then set_camera_shake_from_hit(SHAKE_GROUND_POUND) end

            return set_mario_action(m, ACT_VEPH_GROUND_POUND_LAND, 0)
            
        elseif (stepResult ~= WATER_STEP_NONE) then
            mario_set_forward_vel(m, -16.0)
            if (m.vel.y > 0.0) then
                m.vel.y = 0.0
            end

            set_mario_particle_flags(m, PARTICLE_VERTICAL_STAR, false)
            play_character_sound(m, CHAR_SOUND_OOOF)
            return set_mario_action(m, ACT_BACKWARD_WATER_KB, 0)
        end
    end

    m.actionTimer = m.actionTimer + 1
    return false
end
hook_mario_action(ACT_VEPH_GROUND_POUND, act_veph_ground_pound, INT_GROUND_POUND_OR_TWIRL)

--Underwater Ground Pound Landing action
--- @param m MarioState
function act_veph_ground_pound_land(m)
    --Cancel by pressing A or B
    if m.actionTimer ~= 0 then
        if (m.input & INPUT_A_PRESSED) ~= 0 then
            play_sound(SOUND_ACTION_SWIM_FAST, m.marioObj.header.gfx.cameraToObject)
            return set_mario_action(m, ACT_BREASTSTROKE, 0)
        elseif (m.input & INPUT_B_PRESSED) ~= 0 then
            return set_mario_action(m, ACT_WATER_PUNCH, 0)
        end
    end

    if m.actionTimer <= 5 then
        set_mario_animation(m, MARIO_ANIM_GROUND_POUND_LANDING)
    else
        return set_mario_action(m, ACT_SWIMMING_END, 0)
    end

    --Reset our angle
    vec3s_set(m.angleVel, 0, 0, 0)
    m.marioObj.header.gfx.angle.x = 0
    m.marioObj.header.gfx.angle.z = 0

    m.actionTimer = m.actionTimer + 1
    return false
end
hook_mario_action(ACT_VEPH_GROUND_POUND_LAND, act_veph_ground_pound_land)

--Apply Veph's model
--- @param o Object
function veph_model(o, modelId)
    local modeltype = VP_REPLACE_MODELS[modelId]
    if modeltype == nil then return end
    
    local m = gMarioStates[network_local_index_from_global(o.globalPlayerIndex)]
    local vephenabled = gPlayerSyncTable[m.playerIndex].vephenabled
    if vephenabled == 1 or vephenabled == 2
    or gVephVariables[m.playerIndex].wasveph then
        --Force playing as Mario
        if m.character.type ~= CT_MARIO then
            m.character = gCharacters[CT_MARIO]
        end
        
        --Set the model!
        local colorless = vephenabled == 2
        if modeltype == VP_REPLACE_PLAYER then
            obj_set_model_extended(o, colorless and E_MODEL_VEPH_C or E_MODEL_VEPH)
        elseif modeltype == VP_REPLACE_CAP then
            obj_set_model_extended(o, colorless and E_MODEL_VEPH_C_CAP or E_MODEL_VEPH_CAP)
        elseif modeltype == VP_REPLACE_METAL then
            obj_set_model_extended(o, colorless and E_MODEL_VEPH_C_METAL_CAP or E_MODEL_VEPH_METAL_CAP)
        elseif modeltype == VP_REPLACE_WING then
            obj_set_model_extended(o, colorless and E_MODEL_VEPH_C_WING_CAP or E_MODEL_VEPH_WING_CAP)
        elseif modeltype == VP_REPLACE_METALWING then
            obj_set_model_extended(o, colorless and E_MODEL_VEPH_C_WINGED_METAL_CAP or E_MODEL_VEPH_WINGED_METAL_CAP)
        end
    end
end
hook_event(HOOK_OBJECT_SET_MODEL, veph_model)

--Main function
--- @param m MarioState
function veph_update(m)
    local v = gVephVariables[m.playerIndex]
    local vephenabled = gPlayerSyncTable[m.playerIndex].vephenabled
    if vephenabled ~= 1 and vephenabled ~= 2 and vephenabled ~= 3 then
        if v.wasveph then
            v.wasveph = false
        end
        return
    end
    v.wasveph = vephenabled ~= 3

    local grounded = (m.action & ACT_FLAG_AIR) == 0
    local wasgrounded = (v.vephprevaction & ACT_FLAG_AIR) == 0

    --Set Model
    --[[
    if vephenabled ~= 3 then
        if vephenabled == 2 then
            obj_set_model_extended(m.marioObj, E_MODEL_VEPH_C)
        else
            obj_set_model_extended(m.marioObj, E_MODEL_VEPH)
        end
    end
    ]]--

    --Hack to allow hitting Ground Pound things with the dive
    --And also do an instant charge slime tail out of a ground pound landing
    if m.action == ACT_GROUND_POUND_LAND then
        if v.vephdiving == 1 then
            mario_set_forward_vel(m, v.vephhmom)
            if m.actionTimer >= 1 then
                v.vephdiving = 0
                v.vephhmom = m.forwardVel
                set_mario_action(m, ACT_VEPH_SLIDE, 0)
            else act_veph_slide(m) end
            m.actionTimer = m.actionTimer + 1
        elseif (m.input & INPUT_B_PRESSED) ~= 0 then
            set_mario_action(m, ACT_VEPH_TAIL_CHARGE, 0)
        end
    --[[elseif (m.action & ACT_FLAG_STATIONARY) ~= 0
    and not VP_MOMENTUMACTIONS[m.action] then
        v.vephhmom = 0]]--
    end

    --Squishy
	if v.vephsquish ~= 0 then
		if v.vephsquish > 0 then
			v.vephsquish = v.vephsquish - 1
		else
			v.vephsquish = v.vephsquish + 1
		end

		local factor = 2
		if math.abs(v.vephsquish) <= SQUISHTIME*2/3 then factor = 4 end
		if math.abs(v.vephsquish) <= SQUISHTIME/3 then factor = 8 end

		m.marioObj.header.gfx.scale.x = 1 - math.sin(v.vephsquish/2)/factor
        m.marioObj.header.gfx.scale.z = m.marioObj.header.gfx.scale.x
		m.marioObj.header.gfx.scale.y = 1 + math.sin(v.vephsquish/2)/factor
	end

    --Jump sounds
    if vephenabled == 3 then
        --Not in modelless mode!

    --First jump
    elseif (m.action == ACT_JUMP or m.action == ACT_STEEP_JUMP
    or m.action == ACT_WATER_JUMP) and wasgrounded then
        veph_play_sound(m.pos, "DSVPJMP1.mp3")

    --Double jump sound and animation
    elseif m.action == ACT_DOUBLE_JUMP then
        if wasgrounded then veph_play_sound(m.pos, "DSVPJMP2.mp3") end

        set_mario_animation(m, MARIO_ANIM_SLIDE_MOTIONLESS)
        smlua_anim_util_set_animation(m.marioObj, "veph_backflip")
        set_anim_to_frame(m, m.actionTimer)
        
        m.actionTimer = m.actionTimer + 1

    --Triple jump
    elseif (m.action == ACT_TRIPLE_JUMP or m.action == ACT_FLYING_TRIPLE_JUMP
    or m.action == ACT_HOLD_METAL_WATER_JUMP or m.action == ACT_HOLD_METAL_WATER_JUMP
    or m.action == ACT_SPECIAL_TRIPLE_JUMP) and wasgrounded then
        veph_play_sound(m.pos, "DSVPJMP3.mp3")
    end

    --Cancel slide end by moving
    if (m.action == ACT_STOMACH_SLIDE_STOP or m.action == ACT_DIVE_PICKING_UP) and v.vephdiving ~= 0 then
        local grabbing = m.action == ACT_DIVE_PICKING_UP
        if (m.input & INPUT_A_PRESSED) ~= 0 then
            set_jumping_action(m, grabbing and ACT_HOLD_JUMP or ACT_JUMP, 0)
        elseif m.intendedMag ~= 0 then
            set_mario_action(m, grabbing and ACT_HOLD_WALKING or ACT_WALKING, 0)
        end

    --Start Dolphin Dive by pressing A midair
    elseif VP_MOVEACTIONS[m.action] and (v.vephdiving == 0 or v.vephdiving == 3)
    and not (m.action == ACT_LONG_JUMP and m.forwardVel < 8)
    and not grounded and v.vephprevaction == m.action and (m.input & INPUT_A_PRESSED) ~= 0 then
        set_mario_action(m, ACT_VEPH_DIVE, 1)

    --Start Slime Tail pressing B during a long jump/backflip
    elseif (m.action == ACT_LONG_JUMP or m.action == ACT_BACKFLIP)
    and (m.input & INPUT_B_PRESSED) ~= 0 then
        set_mario_action(m, ACT_VEPH_TAIL_AIR, 1)

    --Start a ground pound underwater
    elseif VP_WATERACTIONS[m.action] and (m.input & INPUT_Z_PRESSED) ~= 0 then
        mario_drop_held_object(m)
        set_mario_action(m, ACT_VEPH_GROUND_POUND, 0)
    end
    
    --Face our momentum angle when diving
    if m.action == ACT_VEPH_DIVE then
        m.marioObj.header.gfx.angle.x = atan2s(m.forwardVel, -m.vel.y)

        --Hop Twirl
        if v.vephdiving == 2 then
            if m.actionTimer >= 12 then
                v.vephdiving = 0
            elseif m.actionTimer < 8 then
                local angle = m.actionTimer*0x2000
                m.marioObj.header.gfx.angle.z = angle
                m.marioObj.header.gfx.animInfo.animYTrans = 0
            end
        end

    --How can we be diving when we're not diving?
    elseif v.vephdiving ~= 0 and m.action ~= ACT_STOMACH_SLIDE_STOP
    and m.action ~= ACT_GROUND_POUND_LAND and m.action ~= ACT_DIVE_PICKING_UP then
        v.vephdiving = 0
    end

    --Slime Tail Charging
    if v.vephtail ~= 0 and m.action ~= ACT_VEPH_TAIL_AIR
    and m.action ~= ACT_VEPH_TAIL_GROUND then
        --We failed to activate the charge
        if v.vephtail < TAILTIME or (m.controller.buttonDown & B_BUTTON) == 0
        or (grounded and not VP_CHARGEACTIONS[m.action]) then
            v.vephtail = 0

        --Charging!
        elseif grounded then
            v.vephtail = v.vephtail + 1
            if v.vephtail >= TAILTIME*2 then
                v.vephtail = 0
                set_mario_action(m, ACT_VEPH_TAIL_CHARGE, 0)
            end
        end

    --Allow charging out of punching/kicking too!
    elseif (m.prevAction == ACT_PUNCHING or m.prevAction == ACT_MOVE_PUNCHING
    or m.prevAction == ACT_JUMP_KICK) and VP_CHARGEACTIONS[m.action]
    and (m.controller.buttonDown & B_BUTTON) ~= 0 then
        v.vephtail = TAILTIME*1.5
    end

    --Let us Water Drive again if we're grounded
    if v.vephtailed ~= 0 and grounded then
        v.vephtailed = 0
    end

    --Don't allow easy turning when wall jumping
    if m.action == ACT_WALL_KICK_AIR then
        v.vephwalljump = true
    elseif v.vephwalljump and grounded then
        v.vephwalljump = false
    end

    --Infinite air underwater
    --Just stops your health from draining, if you actually healed that'd be dumb
    if m.health >= 0x100 and (m.healCounter | m.hurtCounter) == 0
    and (m.action & ACT_FLAG_INTANGIBLE) == 0 and (m.input & INPUT_IN_POISON_GAS) == 0
    and (m.action & ACT_FLAG_SWIMMING) ~= 0 and m.pos.y < (m.waterLevel - 140) then
        m.health = m.health + 1
    end

    --Automatically jump out of water when doing a flutter kick
    if (m.action == ACT_FLUTTER_KICK or m.action == ACT_HOLD_FLUTTER_KICK)
    and m.pos.y + 1.5 >= m.waterLevel - 80
    and m.faceAngle.x >= 0 and m.controller.stickY < 0 then
        local hmom = math.max(m.forwardVel, v.vephswim)
        mario_set_forward_vel(m, hmom*1.5)
        m.vel.y = hmom * sins(m.faceAngle.x)
        vec3s_set(m.angleVel, 0, 0, 0)

        play_sound(SOUND_ACTION_UNKNOWN432, m.marioObj.header.gfx.cameraToObject)
        set_mario_action(m, ACT_VEPH_DIVE, 0)
        v.vephwatercamaction = ACT_VEPH_DIVE
    end

    --Reset the water camera when our action updates
    if v.vephwatercamaction ~= 0 and v.vephwatercamaction ~= m.action then
        v.vephwatercamaction = 0
        if m.playerIndex == 0 and (m.action & ACT_FLAG_SWIMMING) == 0 then
            set_camera_mode(m.area.camera, m.area.camera.defMode, 1)
        end
    end

    --Extra health loss with electricity
    if v.vephprevhurt ~= m.hurtCounter then
        if v.vephprevhurt == 0 and m.hurtCounter > 0
        and (m.action == ACT_SHOCKED or m.action == ACT_WATER_SHOCKED) then
            m.hurtCounter = math.max(m.hurtCounter, 15)
        end
        v.vephprevhurt = m.hurtCounter
    end

    --Get our animation
    --Play the laugh line if we're in the winner animation!
    local animation = m.marioObj.header.gfx.animInfo.animID
    if m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_TAKE_CAP_OFF_THEN_ON
    and v.vephprevanim ~= animation then
        play_character_sound(m, CHAR_SOUND_HAHA)
    end

    --Utilize the eye switching more with Veph!
    local eyeswitched = false
    local blinking = m.marioBodyState.eyeState == MARIO_EYES_BLINK
    or m.marioBodyState.eyeState == MARIO_EYES_OPEN

    --No eye switching for you!
    if vephenabled == 3 or not blinking then
        --None!

    --Put on Veph's goggles while underwater
    --Don't do this if we don't have goggles!
    elseif (m.action == ACT_GROUND_POUND_LAND and v.vephdiving > 0)
    or (((m.action & (ACT_FLAG_SWIMMING|ACT_FLAG_METAL_WATER)) ~= 0 or m.action == ACT_STAR_DANCE_WATER)
    and (m.flags & MARIO_CAP_ON_HEAD) ~= 0) then
        m.marioBodyState.eyeState = MARIO_EYES_LOOK_LEFT
        eyeswitched = true

    --Open mouth during breakdance
    elseif (m.action == ACT_PUNCHING or m.action == ACT_MOVE_PUNCHING) and m.actionArg == 9 then
        m.marioBodyState.eyeState = MARIO_EYES_LOOK_RIGHT
        eyeswitched = true

    --Look down during a kick
    elseif (m.action == ACT_PUNCHING or m.action == ACT_MOVE_PUNCHING
    or m.action == ACT_JUMP_KICK) and (m.flags & MARIO_KICKING) ~= 0 then
        m.marioBodyState.eyeState = MARIO_EYES_LOOK_DOWN
        eyeswitched = true

    --Dead eyes in deep quicksand
    elseif animation == MARIO_ANIM_DYING_IN_QUICKSAND then
        m.marioBodyState.eyeState = MARIO_EYES_DEAD
        eyeswitched = true

    --Other eye states
    elseif VP_EYEACTIONS[m.action] ~= nil then
        m.marioBodyState.eyeState = VP_EYEACTIONS[m.action]
        eyeswitched = true
    end

    --Now, let's check what voice clip was playing to do eye stuff
    if eyeswitched or vephenabled == 3 or not blinking then
        v.vephvoicetimer = 0
        v.vephvoiceeyes = MARIO_EYES_BLINK
    elseif v.vephvoicetimer > 0 then
        v.vephvoicetimer = v.vephvoicetimer - 1
        m.marioBodyState.eyeState = v.vephvoiceeyes
    end

    --Update prev stuff
    v.vephprevaction = m.action
    v.vephprevanim = animation
    v.vephprevhmom = m.forwardVel
    v.vephprevmomy = m.vel.y
end
hook_event(HOOK_MARIO_UPDATE, veph_update)

--Super fast flutter kick
--This code will execute even while not in a flutter kick so as to allow momentum preservation
function veph_swim(m)
    local v = gVephVariables[m.playerIndex]
    local vephenabled = gPlayerSyncTable[m.playerIndex].vephenabled
    if vephenabled ~= 1 and vephenabled ~= 2 and vephenabled ~= 3 then return end

    --Momentum preservation (kinda unrelated to the flutter kick, oops!)
    --[[if v.vephhmom < m.forwardVel or m.forwardVel <= 0
    or not VP_MOMENTUMACTIONS[m.action] then
        v.vephhmom = m.forwardVel
    else
        v.vephhmom = math.max(v.vephhmom - 2, m.forwardVel)
        mario_set_forward_vel(m, v.vephhmom)
        return
    end]]--
    
    --Start
    if ((m.action ~= ACT_FLUTTER_KICK or m.action ~= ACT_HOLD_FLUTTER_KICK)
    and (not VP_WATERACTIONS[m.action] or v.vephswim < m.forwardVel))
    or m.forwardVel <= 0 then
        v.vephswim = m.forwardVel
        return
    end

    --Update speed variable
    if m.action == ACT_FLUTTER_KICK or m.action == ACT_HOLD_FLUTTER_KICK then
        v.vephswim = math.min(math.max(v.vephswim + 2, m.forwardVel), SWIMSPEED)
        if m.action == ACT_HOLD_FLUTTER_KICK then
            set_mario_anim_with_accel(m, MARIO_ANIM_FLUTTERKICK_WITH_OBJ, v.vephswim * 0x800)
        else
            set_mario_anim_with_accel(m, MARIO_ANIM_FLUTTERKICK, v.vephswim * 0x800)
        end

        local animFrame = m.marioObj.header.gfx.animInfo.animFrame
        if m.forwardVel >= 14.0 and (animFrame == 0 or animFrame == 12) then
            if animFrame == 0 then
                play_sound(SOUND_ACTION_UNKNOWN434, m.marioObj.header.gfx.cameraToObject)
            else
                play_sound(SOUND_ACTION_SWIM, m.marioObj.header.gfx.cameraToObject)
            end
        end
    elseif (m.action == ACT_WATER_PUNCH or m.action == ACT_WATER_THROW)
    and m.actionTimer == 0 then
        v.vephswim = math.max(v.vephswim/2, m.forwardVel)
        m.actionTimer = m.actionTimer + 1
    else
        v.vephswim = math.max(v.vephswim - 1, m.forwardVel)
    end
    local factor = math.min(v.vephswim/48, 1)

    --Fast bubble effect
    if v.vephswim >= SWIMSPEED*0.825 then
        m.particleFlags = m.particleFlags | PARTICLE_PLUNGE_BUBBLE
    end

    --Update pitch for faster turning (vertical)
    local targetPitch = -(252.0 * m.controller.stickY)

    local pitchVel = 0x200
    if m.faceAngle.x < 0 then
        pitchVel = 0x100
    end
    pitchVel = pitchVel*factor*math.abs(m.controller.stickY*m.controller.stickY/4096)

    if (m.faceAngle.x < targetPitch) then
        m.faceAngle.x = m.faceAngle.x + pitchVel
        if (m.faceAngle.x > targetPitch) then
            m.faceAngle.x = targetPitch
        end
    elseif (m.faceAngle.x > targetPitch) then
        m.faceAngle.x = m.faceAngle.x - pitchVel
        if (m.faceAngle.x < targetPitch) then
            m.faceAngle.x = targetPitch
        end
    end

    --Update Yaw for faster turning (horiztonal)
    local targetYawVel = -(10.0 * m.controller.stickX)
    factor = factor*2*math.abs(m.controller.stickX*m.controller.stickX/4096)
    
    if (targetYawVel > 0) then
        if (m.angleVel.y < 0) then
            m.angleVel.y = m.angleVel.y + 0x40*factor
            if (m.angleVel.y > 0x10*factor) then
                m.angleVel.y = 0x10*factor
            end
        else
            m.angleVel.y = approach_s32(m.angleVel.y, targetYawVel, 0x10*factor, 0x20*factor)
        end
    elseif (targetYawVel < 0) then
        if (m.angleVel.y > 0) then
            m.angleVel.y = m.angleVel.y - 0x40*factor
            if (m.angleVel.y < -0x10*factor) then
                m.angleVel.y = -0x10*factor
            end
        else
            m.angleVel.y = approach_s32(m.angleVel.y, targetYawVel, 0x10*factor, 0x20*factor)
        end
    end

    m.faceAngle.y = m.faceAngle.y + m.angleVel.y
    m.faceAngle.z = -m.angleVel.y * 8

    --Update actual speed
    m.forwardVel = v.vephswim
    m.vel.x = m.forwardVel * coss(m.faceAngle.x) * sins(m.faceAngle.y)
    m.vel.y = m.forwardVel * sins(m.faceAngle.x)
    m.vel.z = m.forwardVel * coss(m.faceAngle.x) * coss(m.faceAngle.y)
end
hook_event(HOOK_BEFORE_PHYS_STEP, veph_swim)

--Command to enable Veph
function veph_command(msg)
    if msg == 'on' or msg == '1' then
        djui_chat_message_create('You are now playing as Veph!')
        gPlayerSyncTable[0].vephenabled = 1
    elseif string.sub(msg, 1, 1) == 'c' or msg == '2' then
        djui_chat_message_create('You are now playing as Veph with his original colors!')
        gPlayerSyncTable[0].vephenabled = 2
    elseif string.sub(msg, 1, 1) == 'm' or msg == '3' then
        djui_chat_message_create('You are now playing as Veph with your current model!')
        gPlayerSyncTable[0].vephenabled = 3
    elseif msg == 'off' or msg == '0' then
        djui_chat_message_create('You are no longer playing as Veph.')
        gPlayerSyncTable[0].vephenabled = 0
    else
        djui_chat_message_create("/veph [on/off/colorless/modelless] - Toggles whether you're playing as Veph. Colorless/Modelless will disable color-changing and Veph's model respectively.")
    end
    return true
end
hook_chat_command("veph", "[on/off/colorless/modelless] - Toggles whether you're playing as Veph. Colorless/Modelless will disable color-changing and Veph's model respectively.", veph_command)

--Command to toggle Veph's goop
function vephgoop_command(msg)
    if not (network_is_moderator() or network_is_server()) then
        djui_chat_message_create("This command is admin-only!")
    elseif msg == 'on' then
        djui_chat_message_create("Veph's Slime Tail now uses the custom goop object.")
        gGlobalSyncTable.vephgoop = true
    elseif msg == 'off' then
        djui_chat_message_create("Veph's Slime Tail now uses basic particle effects.")
        gGlobalSyncTable.vephgoop = false
    else
        djui_chat_message_create("/vephgoop [on/off] - Toggles whether Veph's Slime Tail uses the custom goop object. Otherwise, it will use basic particle effects.")
    end
    return true
end
hook_chat_command("vephgoop", "[on/off] - Toggles whether Veph's Slime Tail uses the custom goop object. Otherwise, it will use basic particle effects.", vephgoop_command)