--This is a version of my freely modifiable custom voice script
--I recommend using the Toad one as a base, as this one has modifications specific to Veph

--Define what triggers the custom voice
local function use_custom_voice(m)
    return gVephVariables[m.playerIndex].wasveph --Put your condition here!
end

--How many snores the sleep-talk has, or rather, how long the sleep-talk lasts
--If you omit the sleep-talk you can ignore this
local SLEEP_TALK_SNORES = 8

--Define what actions play what voice clips
--If an action has more than one voice clip, put those clips inside a table
--CHAR_SOUND_SNORING3 requires two or three voice clips to work properly...
--but you can omit it if your character does not sleep-talk
local CUSTOM_VOICETABLE = {
    [CHAR_SOUND_ATTACKED] = 'VEPH_HURT1.mp3',
    [CHAR_SOUND_COUGHING1] = 'VEPH_UH.mp3',
    [CHAR_SOUND_COUGHING2] = 'VEPH_UH.mp3',
    [CHAR_SOUND_COUGHING3] = 'VEPH_UH.mp3',
    [CHAR_SOUND_DOH] = 'VEPH_HURT2.mp3',
    [CHAR_SOUND_DROWNING] = 'VEPH_DIE.mp3',
    [CHAR_SOUND_DYING] = 'VEPH_DIE.mp3',
    [CHAR_SOUND_EEUH] = 'VEPH_PULLUP.mp3',
    [CHAR_SOUND_GAME_OVER] = 'VEPH_DIE.mp3',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'VEPH_CHARGE.mp3',
    [CHAR_SOUND_HAHA] = 'VEPH_LAUGH.mp3',
    [CHAR_SOUND_HAHA_2] = 'VEPH_LAUGH.mp3',
    [CHAR_SOUND_HELLO] = 'VEPH_HAPPY.mp3',
    [CHAR_SOUND_HERE_WE_GO] = 'VEPH_WIN.mp3',
    [CHAR_SOUND_HOOHOO] = 'VEPH_ATTACK2.mp3',
    [CHAR_SOUND_HRMM] = 'VEPH_PULLUP.mp3',
    --[CHAR_SOUND_IMA_TIRED] = nil,
    [CHAR_SOUND_LETS_A_GO] = 'VEPH_TAUNT2.mp3',
    --[CHAR_SOUND_MAMA_MIA] = nil,
    [CHAR_SOUND_OKEY_DOKEY] = 'VEPH_HAPPY.mp3',
    [CHAR_SOUND_ON_FIRE] = 'VEPH_LAVA.mp3',
    [CHAR_SOUND_OOOF] = 'VEPH_HURT1.mp3',
    [CHAR_SOUND_OOOF2] = 'VEPH_HURT1.mp3',
    [CHAR_SOUND_PANTING] = 'VEPH_SNORE.mp3',
    [CHAR_SOUND_PANTING_COLD] = 'VEPH_SNORE.mp3',
    [CHAR_SOUND_PRESS_START_TO_PLAY] = 'VEPH_TAUNT1.mp3',
    [CHAR_SOUND_PUNCH_HOO] = 'VEPH_PUNCH3.mp3',
    [CHAR_SOUND_PUNCH_WAH] = 'VEPH_PUNCH2.mp3',
    [CHAR_SOUND_PUNCH_YAH] = 'VEPH_PUNCH1.mp3',
    [CHAR_SOUND_SNORING1] = 'VEPH_INHALE.mp3',
    [CHAR_SOUND_SNORING2] = 'VEPH_SNORE.mp3',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'VEPH_TAUNT1.mp3',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'VEPH_HAPPY.mp3',
    --[CHAR_SOUND_UH] = nil,
    [CHAR_SOUND_UH2] = 'VEPH_ATTACK1.mp3',
    --[CHAR_SOUND_UH2_2] = nil,
    [CHAR_SOUND_WAAAOOOW] = 'VEPH_SCREAM.mp3',
    [CHAR_SOUND_WAH2] = 'VEPH_CHARGE.mp3',
    [CHAR_SOUND_WHOA] = 'VEPH_HURT1.mp3',
    [CHAR_SOUND_YAHOO] = 'VEPH_HAPPY.mp3',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'VEPH_HAPPY.mp3',
    [CHAR_SOUND_YAH_WAH_HOO] = 'VEPH_ATTACK1.mp3',
    [CHAR_SOUND_YAWNING] = 'VEPH_YAWN.mp3',
}

--Special Veph constant, which voices do which eye state! MARIO_EYES_LOOK_RIGHT by default
VP_VOICEEYES = {
    ['VEPH_DIE.mp3'] = MARIO_EYES_DEAD,
    ['VEPH_FALL.mp3'] = MARIO_EYES_DEAD,
    ['VEPH_HURT1.mp3'] = MARIO_EYES_DEAD,
    ['VEPH_HURT2.mp3'] = MARIO_EYES_DEAD,
    ['VEPH_LAVA.mp3'] = MARIO_EYES_DEAD,
    ['VEPH_SCREAM.mp3'] = MARIO_EYES_DEAD,
    ['VEPH_UH.mp3'] = MARIO_EYES_DEAD,
}

--How long each voice lasts
VP_VOICELENGTHS = {
    ['VEPH_ATTACK1.mp3'] = 7,
    ['VEPH_ATTACK2.mp3'] = 10,
    ['VEPH_CHARGE.mp3'] = 15,
    ['VEPH_DIE.mp3'] = 68,
    ['VEPH_FALL.mp3'] = 37,
    ['VEPH_HAPPY.mp3'] = 25,
    ['VEPH_HURT1.mp3'] = 14,
    ['VEPH_HURT2.mp3'] = 17,
    ['VEPH_INHALE.mp3'] = 26,
    ['VEPH_LAUGH.mp3'] = 27,
    ['VEPH_LAVA.mp3'] = 37,
    ['VEPH_PICKUP.mp3'] = 11,
    ['VEPH_POWERUP.mp3'] = 22,
    ['VEPH_PULLUP.mp3'] = 15,
    ['VEPH_PUNCH1.mp3'] = 7,
    ['VEPH_PUNCH2.mp3'] = 10,
    ['VEPH_PUNCH3.mp3'] = 15,
    ['VEPH_SCREAM.mp3'] = 64,
    ['VEPH_SNORE.mp3'] = 8,
    ['VEPH_TAUNT1.mp3'] = 22,
    ['VEPH_TAUNT2.mp3'] = 30,
    ['VEPH_UH.mp3'] = 7,
    ['VEPH_WIN.mp3'] = 50,
    ['VEPH_YAWN.mp3'] = 25,
}

--Define the table of samples that will be used for each player
--Global so if multiple mods use this they won't create unneeded samples
--DON'T MODIFY THIS SINCE IT'S GLOBAL FOR USE BY OTHER MODS!
gCustomVoiceSamples = {}
gCustomVoiceStream = nil

--Get the player's sample, stop whatever sound
--it's playing if it doesn't match the provided sound
--DON'T MODIFY THIS SINCE IT'S GLOBAL FOR USE BY OTHER MODS!
--- @param m MarioState
function stop_custom_character_sound(m, sound)
    local voice_sample = gCustomVoiceSamples[m.playerIndex]
    if voice_sample == nil or not voice_sample.loaded then
        return
    end

    audio_sample_stop(voice_sample)
    if voice_sample.file.relativePath:match('^.+/(.+)$') == sound then
        return voice_sample
    end
    audio_sample_destroy(voice_sample)
end

--Play a custom character's sound
--DON'T MODIFY THIS SINCE IT'S GLOBAL FOR USE BY OTHER MODS!
--- @param m MarioState
function play_custom_character_sound(m, voice)
    --Get sound, if it's a table, get a random entry from it
    local sound
    if type(voice) == "table" then
        sound = voice[math.random(#voice)]
    else
        sound = voice
    end
    if sound == nil then return 0 end

    --Get current sample and stop it
    local voice_sample = stop_custom_character_sound(m, sound)

    --If the new sound isn't a string, let's assume it's
    --a number to return to the character sound hook
    if type(sound) ~= "string" then
        return sound
    end

    --Load a new sample and play it! Don't make a new one if we don't need to
    if (m.area == nil or m.area.camera == nil) and m.playerIndex == 0 then
        if gCustomVoiceStream ~= nil then
            audio_stream_stop(gCustomVoiceStream)
            audio_stream_destroy(gCustomVoiceStream)
        end
        gCustomVoiceStream = audio_stream_load(sound)
        audio_stream_play(gCustomVoiceStream, true, 1)
    else
        if voice_sample == nil then
            voice_sample = audio_sample_load(sound)
        end
        audio_sample_play(voice_sample, m.pos, 1)

        gCustomVoiceSamples[m.playerIndex] = voice_sample
    end
    return 0
end

--Main character sound hook
--This hook is freely modifiable in case you want to make any specific exceptions
--- @param m MarioState
local function custom_character_sound(m, characterSound)
    if not use_custom_voice(m) then return end
    if characterSound == CHAR_SOUND_SNORING3 then return 0 end
    if characterSound == CHAR_SOUND_HAHA and m.hurtCounter > 0 then return 0 end

    --Don't play Veph's voices when jumping
    if (characterSound == CHAR_SOUND_YAH_WAH_HOO
    or characterSound == CHAR_SOUND_YAHOO
    or characterSound == CHAR_SOUND_YAHOO_WAHA_YIPPEE
    or characterSound == CHAR_SOUND_HOOHOO)
    and (m.action == ACT_JUMP or m.action == ACT_STEEP_JUMP
    or m.action == ACT_WATER_JUMP or m.action == ACT_DOUBLE_JUMP
    or m.action == ACT_TRIPLE_JUMP or m.action == ACT_FLYING_TRIPLE_JUMP
    or m.action == ACT_HOLD_METAL_WATER_JUMP or m.action == ACT_HOLD_METAL_WATER_JUMP
    or m.action == ACT_SPECIAL_TRIPLE_JUMP) then
        return 0
    end

    local voice = CUSTOM_VOICETABLE[characterSound]
    if (m.action == ACT_PUNCHING or m.action == ACT_MOVE_PUNCHING)
    and m.actionArg == 9 then
        voice = "VEPH_TAUNT1.mp3" --Custom Veph breakdance voice
    elseif m.action == ACT_SHOCKED then
        voice = "VEPH_LAVA.mp3" --Custom Veph electricution voice
    elseif (m.action == ACT_DEATH_EXIT_LAND and voice ~= nil)
    or m.action == ACT_HARD_FORWARD_GROUND_KB
    or m.action == ACT_HARD_BACKWARD_GROUND_KB then
        voice = "VEPH_FALL.mp3" --Custom Veph hurt land voice
    elseif voice == 0
    and (m.action == ACT_FORWARD_AIR_KB
    or m.action == ACT_BACKWARD_AIR_KB
    or m.action == ACT_HARD_FORWARD_AIR_KB
    or m.action == ACT_HARD_BACKWARD_AIR_KB) then
        voice = "VEPH_HURT2.mp3" --Custom Veph hurt voice
    elseif m.action == ACT_PUTTING_ON_CAP then
        voice = "VEPH_POWERUP.mp3" --Custom Veph hat get voice
    end
    
    if voice ~= nil then
        local v = gVephVariables[m.playerIndex]
        v.vephvoicetimer = VP_VOICELENGTHS[voice] or 15
        v.vephvoiceeyes = VP_VOICEEYES[voice] or MARIO_EYES_LOOK_RIGHT
        
        return play_custom_character_sound(m, voice)
    end
    return 0
end
hook_event(HOOK_CHARACTER_SOUND, custom_character_sound)

--Snoring logic for CHAR_SOUND_SNORING3 since we have to loop it manually
--This code won't activate on the Japanese version, due to MARIO_MARIO_SOUND_PLAYED not being set
local SNORE3_TABLE = CUSTOM_VOICETABLE[CHAR_SOUND_SNORING3]
local STARTING_SNORE = 46
local SLEEP_TALK_START = STARTING_SNORE + 49
local SLEEP_TALK_END = SLEEP_TALK_START + SLEEP_TALK_SNORES

--Main hook for snoring
--- @param m MarioState
local function custom_character_snore(m)
    if not use_custom_voice(m) then return end

    --Stop the snoring!
    if m.action ~= ACT_SLEEPING then
        if m.isSnoring > 0 then
            stop_custom_character_sound(m)
        end
        return

    --You're not in deep snoring
    elseif not (m.actionState == 2 and (m.flags & MARIO_MARIO_SOUND_PLAYED) ~= 0) then
        return
    end

    local animFrame = m.marioObj.header.gfx.animInfo.animFrame

    --Behavior for CHAR_SOUND_SNORING3
    if SNORE3_TABLE ~= nil and #SNORE3_TABLE >= 2 then
        --Exhale sound
        if animFrame == 2 and m.actionTimer < SLEEP_TALK_START then
            play_custom_character_sound(m, SNORE3_TABLE[2])

        --Inhale sound
        elseif animFrame == 25 then
            
            --Count up snores
            if #SNORE3_TABLE >= 3 then
                m.actionTimer = m.actionTimer + 1

                --End sleep-talk
                if m.actionTimer >= SLEEP_TALK_END then
                    m.actionTimer = STARTING_SNORE
                end
    
                --Enough snores? Start sleep-talk
                if m.actionTimer == SLEEP_TALK_START then
                    play_custom_character_sound(m, SNORE3_TABLE[3])
                
                --Regular snoring
                elseif m.actionTimer < SLEEP_TALK_START then
                    play_custom_character_sound(m, SNORE3_TABLE[1])
                end
            
            --Definitely regular snoring
            else
                play_custom_character_sound(m, SNORE3_TABLE[1])
            end
        end

    --No CHAR_SOUND_SNORING3, just use regular snoring
    elseif animFrame == 2 then
        play_character_sound(m, CHAR_SOUND_SNORING2)

    elseif animFrame == 25 then
        play_character_sound(m, CHAR_SOUND_SNORING1)
    end
end
hook_event(HOOK_MARIO_UPDATE, custom_character_snore)